/*
 * RatingRadioRenderer
 * by PhilFlash - http://philflash.inway.fr
 *
 * Dont't forget :
 * - to create a new symbol in Flash MX2004
 *   Insert > New Symbol
 *   with properties :
 *    Name : RatingRadioRenderer
 *    Behavior : MovieClip : Checked
 *   For Linkage:
 *    Identifier: RatingRadioRenderer
 *    AS 2.0 Class : renderer.RatingRadioRenderer
 *    Export for Actionscript : Checked
 *    Export for in first frame : Checked
 *
 * - to insert a RadioButton component in the Library
 *   (Drag a RadioButton to the stage and delete it).
 *
 * Permet de sélectionner avec des radios une valeur de 1 à 5
 * On utilise des chaines de caractères : "1", "2", etc...
 */

import mx.core.UIComponent
import mx.controls.RadioButton

class renderer.RatingRadioRenderer extends UIComponent
{
	private var radioTotal:Number = 5;
	private var radioWidth:Number = 18;
	private var startX:Number = 5;
	private var deltaX:Number = 2;
	private var contentWidth:Number;
	
	private var radios:Array; 

 	var owner; // The row that contains this cell	
	var listOwner : MovieClip; // the reference we receive to the list
	var getCellIndex : Function; // the function we receive from the list
	var	getDataLabel : Function; // the function we receive from the list

	
	function RatingRadioRenderer()
	{
	}
	
	function init(Void):Void
	{
		super.init();
		contentWidth = (startX*2)+(radioWidth*radioTotal)+(deltaX*(radioTotal-1));
		radios = new Array();
	}
	
	function createChildren(Void):Void
	{
		var groupName:String = "group";
		var radio:RadioButton;
		for (var i:Number = 0; i < radioTotal; i++) {
			var indice:Number = i + 1;
			radio = mx.controls.RadioButton(createObject("RadioButton", "ra"+indice, indice));
			radio.label = "";
			radio.data = ""+indice;
			radio.groupName = groupName; 
			radio.labelPlacement = "bottom";
			
			radios.push(radio);
		}
		
		// Listener sur le group pour prendre en compte 
		// les touches (droite, gauche)
		var g = radio._parent[groupName];
		g.addEventListener("click", this);
	}

	function size(Void):Void
	{
		// layout the content
		doLayout();
	}
	
	function doLayout(Void):Void
	{
		var w:Number = __width;
		var h:Number = __height;
    	var x:Number = (__width - contentWidth) / 2;
    	x += startX;
		
		// 12 : minimal value for radio height
		for (var i:Number = 0; i < radioTotal; i++) {
		 	var radio =	radios[i];
		 	// 12 : minimal value for radio height
			radio.setSize(radioWidth,h);
		 	radio._x = x;
		 	radio._y = (__height-12)/2;
		 	x += radioWidth+deltaX;
		}    	
	}
	
	function setValue(value:String, item:Object, sel:Boolean):Void
	{
		if (item == undefined) 
		{
			for (var i:Number = 0; i < radioTotal; i++) {
		 		var radio =	radios[i];
		 		radio._visible = false;
		 	}
		 	return;
		 }
		 
		// On rend visible et on cherche le radio à sélectionner
		var selectedRadio = null;
		var noValue:Boolean = true;
		for (var i:Number = 0; i < radioTotal; i++) {
		 	var radio =	radios[i];
		 	radio._visible = true;
		 	
		 	if (radio.selected) {
		 		selectedRadio = radio;	
		 	}
		 	if (radio.data == value) {
		 		if (!radio.selected) {
		 			radio.selected = true;	
		 		} 
		 		noValue = false;
		 	} 
		 	
		 }
		 // Special case for null value (0)
		 // Valeur non connue => on déselectionne si il existe radio sélectioné
		 if (noValue && selectedRadio != null) {
		 	selectedRadio.selected = false;	
		 }
	}

	function getPreferredHeight(Void):Number
	{
		return 12;
	}

 	//function getPreferredWidth :: only really necessary for menu

	function click(eventObj:Object):Void 
	{
		var target = eventObj.target;
		listOwner.dataProvider.editField(getCellIndex().itemIndex, getDataLabel(), target.selectedData);
	}

}
